-- BOUNDBOX.MS : Bounding Box Maker

-- Category    : Geometry & Helper
-- Environment : MAX 2.0
-- Description : node manipulation & pick button control experiment
-- Reference   :

-- Copyright 1998, EffectWare, Moon-Sun Choi (aeroplus)
-- http://www.chollian.net/~efxware
-- efxware@chollian.net

-- general functions ----------------------------------------------------------

-- cen : ceter point
-- ext : size

fn draw_center_dummy cen ext =
(
    local bbox

    bbox = dummy boxsize:[ext.x, ext.y, ext.z]
    bbox.pos = cen
)

-- cen : ceter point
-- ext : size

fn draw_center_box cen ext =
(
    local bbox

    bbox = box width:ext.x length:ext.y height:ext.z
    -- move pivot
    bbox.pivot.z += ext.z / 2.0
    bbox.pos = cen
)

-- node : selected object
-- mode : box (= false) or dummy (= true)

fn draw_bounding_box node mode =
(
    local ext

    ext = node.max - node.min
    undo on
    (
        if mode == true then draw_center_dummy node.center ext
        else                 draw_center_box node.center ext
    )
	
    ext
)

-- main program ---------------------------------------------------------------

utility bounding_box_maker "Bounding Box Maker"
(
    local node, ext

    group "About"
    (
        label l1 "Bounding Box Maker"
        label l2 "Version 1.0"
        label l3 "Copyright 1998, EffectWare"
        label l4 "Choi, Moon-Sun (aeroplus)"
        label l5 "www.chollian.net/~efxware"
    )

    checkbox dumy "use Dummy" checked:false align:#center
    pickbutton pick_node "  Pick Node  "
    label node_name
    label dimx
    label dimy
    label dimz

    on bounding_box_maker open do
    (
        node_name.text = "None"
    )

    on pick_node picked obj do
    (
        node = obj
        node_name.text = node.name
        ext = draw_bounding_box node dumy.checked
        dimx.text = "X: " + (ext.x as string)
        dimy.text = "Y: " + (ext.y as string)
        dimz.text = "Z: " + (ext.z as string)
    )
)
